#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>
#include <time.h>

#define MAX_HASH 3902
#define MAX_ARRY 3902
#define MULTI 33
#define MAX_STRING 100
#define TEST 100

char hash_table_open[MAX_HASH][MAX_STRING];
char normalArray[MAX_ARRY][MAX_STRING];

/*
* Hashfunction h(k) = 33*k mod m
*/
int hashing(char *string)
{
    unsigned int hashad;
    unsigned char *ptr;
    
    hashad = 0;
    ptr = (unsigned char *)string;
    while(*ptr != '\0')
    {
        hashad = MULTI * hashad + *ptr;  
        ptr++;  
    }   
    
    return hashad % MAX_HASH;
}

/*
* insert an element into a hashtable
*/
void insertHT(char* string)
{
    int hashad;
    hashad = hashing(string);
        
    while(hash_table_open[hashad][0] != 0)
    {
        hashad = (hashad + 1) % MAX_HASH;
    }
    
    strncpy(hash_table_open[hashad],string,MAX_STRING);
}

/*
* Test-Function for the insert-HT
*/
float testInsertHT()
{
    FILE *file;
    char data[100];
    char *name;
    int i;
    clock_t start, end;
    float total;
    
    start = clock();
    for( i = 0; i < TEST; i++)
    {
        file = fopen("Mnner Vornamen.txt","r");
        while(fgets(data,100,file) != 0)
        {
            name = data;
            insertHT(name);
        }
        fclose(file);
        memset(&hash_table_open,0,sizeof(hash_table_open));
    }
    end = clock();
    total = ((float)(end - start))/CLOCKS_PER_SEC;
    return total;
}

/*
* Test-Function for the insert-Array
*/
float testInsertArray()
{
    FILE *file;
    char data[100];
    char *name;
    int count;
    int i;
    clock_t start, end;
    float total;
        
    start = clock();
    for( i = 0; i < TEST; i++)
    {
        count = 0;
        file = fopen("Mnner Vornamen.txt","r");
        while(fgets(data,100,file) != 0)
        {
            name = data;
            strncpy(normalArray[count],name,MAX_STRING);   
            //printf("%s\n",normalArray[count]);    //TEST
            count++;
        }
        fclose(file);
        memset(&normalArray,0,sizeof(normalArray));
    }
    end = clock();
    total = ((float)(end - start))/CLOCKS_PER_SEC;
    return total;
}

/*
* search-Function for arrays
*/
char *searchArray(char *string)
{
    int i = 0;
    for( i = 0; i < MAX_ARRY; i++)
    {
        if(strcmp(normalArray[i],string) == 0)
        {
            return normalArray[i];   
        }
    }  
    return "nichts";
}

/*
* search-Function for HT
*/
char *searchHT(char *string)
{
    int hashad = hashing(string);
    if(strcmp(hash_table_open[hashad],string) == 0)
    {
        return hash_table_open[hashad];
    }
    else
    {
        return "nichts";   
    }   
}

/*
* test for searching in an array
*/
float testSearchArray()
{
    FILE *file;
    char data[100];
    char *name;
    char *erg;
    int i;
    int count = 0;
    clock_t start, end;
    float total;
    
    //Array fllen
    file = fopen("Mnner Vornamen.txt","r");
    while(fgets(data,100,file) != NULL)
    {
        name = data;
        strncpy(normalArray[count],name,MAX_STRING);
        count++;
    }
    fclose(file);
    
    start = clock();
    for( i = 0; i < TEST; i++)
    {
        file = fopen("Mnner Vornamen.txt","r");
        while(fgets(data,100,file) != NULL)
        {
            name = data;
            erg = searchArray(name);
        }   
    }
    end = clock();
    total = ((float)(end - start))/CLOCKS_PER_SEC;
    return total;
}

/*
* test for searching in a HT
*/
float testSearchHT()
{
    FILE *file;
    char data[100];
    char *name;
    char *erg;
    int i;
    clock_t start, end;
    float total;
    
    //Hashtable fllen
    file = fopen("Mnner Vornamen.txt","r");
    while(fgets(data,100,file) != NULL)
    {
        name = data;
        insertHT(name);
    }
    fclose(file);
    
    start = clock();
    for( i = 0; i < TEST; i++)
    {
        file = fopen("Mnner Vornamen.txt","r");
        while(fgets(data,100,file) != NULL)
        {
            name = data;
            erg = searchHT(name);
        }   
    }
    end = clock();
    total = ((float)(end - start))/CLOCKS_PER_SEC;
    return total; 
}

/*
* main-Function
*/
int main(int argc, char *argv[])
{
    printf("Test: Array vs Hashtable\n");
    printf("Values: Size HT: %i ,Size Array: %i ,Iterations: %i \n\n",MAX_HASH,MAX_ARRY,TEST);
    printf("insert:\n");
    printf("\tHT: %f\n",testInsertHT());
    printf("\tArray: %f\n",testInsertArray());
    printf("\nsearch:\n");
    printf("\tHT: %f\n",testSearchHT());
    printf("\tArray: %f\n",testSearchArray());
    printf("Done...\n");
    getchar();	
    return 0;

}
