#include <stdio.h>
#include <stdint.h>
#include <stddef.h>


uint32_t adler(unsigned char *data, size_t datalength)
{    
    uint32_t s1 = 1;
    uint32_t s2 = 0;
    size_t n;
    
    for(n = 0; n < datalength; n++)
    {
        s1 = (s1 + data[n]) % 65521;
        s2 = (s2 + s1) % 65521;   
    }   
    
    return(s2 << 16) | s1;
}

int main(int argc, char *argv[])
{   
    uint32_t erg = adler("hallo Welt", sizeof("hallo Welt"));
    printf("%d",erg);
    getchar();
    return 0;
}
