#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

#define MAX_HASH 10
#define MULTI 31

struct perso
{
    char vname[255];
    char nname[255];
    int age;
    struct perso *next;   
};

typedef struct {
    struct perso *start;
    struct perso *current;
    struct perso *last;
} perso_list;

perso_list hash_table[MAX_HASH];

/*
* Inster a Value into hashtable with seperate chaning
*/
void insert(char *nname, char *vname, int age)
{
    int hash_ad = hashFunctionVarTwo(nname);
    
    perso_list *list = &hash_table[hash_ad];              //Zeiger auf Tabellenad.

    if(list->start == NULL){
        list->start = malloc(sizeof(struct perso));
        list->last = list->start;
    } else {
        list->last->next = malloc(sizeof(struct perso));
        list->last = list->last->next;
    }
    if(!list->last) assert("Memmory");
     
    strcpy(list->last->nname, nname);
    strcpy(list->last->vname, vname);
    list->last->age = age;
}


/*
* Search in the hashtable for a given string.
*/
struct perso *search(char *string)
{
    perso_list list;
    int hashad = hashFunctionVarTwo(string);
    
    list = hash_table[hashad];
    
    list.current = list.start;
    
    while(list.current != NULL)
    {
        if(strcmp(string, list.current->nname)==0)
        {
            return list.current;
        }
        list.current = list.current->next;
    }
    
    return NULL;
}

/*
hashFunctionVarOne: erzeugt aus einem String einen Hashwert, in dem jedes Byte
des String zum Vielfachen des Strings hinzuaddiert.
*/
int hashFunctionVarOne(char *string)
{
    unsigned int hash_add;                      /* unsigned, da nur positive Zahlen */
    unsigned char *pointer;                     /* " */
    
    hash_add = 0;
    pointer = (unsigned char *) string;         /* pointer bekommt den Text bergebn */
    while(*pointer != '\0')                     /* '\0' Ende eines Strings */
    {
        hash_add = MULTI * hash_add + *pointer; /* Hashfunction */
        pointer++;                              /* der Pointer wird erhoeht,d.h auf den naechsten Buchstaben wird gezeigt */
    }
    return hash_add % MAX_HASH;                 /* % = Modulo */
}

/*
hashFunctionVarTwo: Divisionmkethode h(k) = k mod m
*/
int hashFunctionVarTwo(char *string)
{
    unsigned int hash_add;
    unsigned char *pointer;  
    
    hash_add = 0;
    pointer = (unsigned char *) string;
    while(*pointer != '\0')
    {
        hash_add = hash_add + *pointer;
        pointer++;   
    }
    
    return hash_add % MAX_HASH;         
}



/*
*   main-Function for testing
*/
int main(int argc, char *argv[])
{
    int i;
    
    struct perso *a;
        
    insert("Boehme","Paulus",21);
    insert("Albers","Anna",21);
    insert("Hanke","Eva",70);
    insert("Wurst","Hans",55);
    insert("Heisst","Reinsch",88);

    a = search("Boehme");
    
    printf("search: %s %s %i \n", a->vname, a->nname, a->age);
    
    for(i=0; i<MAX_HASH; i++)
    {
       if(hash_table[i].start) printf("inhalt der Hashtabelle an der Adresse %i: %s \n",i,hash_table[i].start->nname);   
    }

    getchar();
}


